@ECHO OFF
REM CDex string: "%1" "%2" "%a" "%b" "%g" "%t" %tn %tt %y

IF NOT "%OS%"=="Windows_NT" GOTO FLAC_Err_NotWinNTx

REM Modify Encoder params
SET sEncoderFile=C:\Program Files\SourceForge\FLAC\flac.exe
SET sEncoderFileExtension=flac

REM Remove double-quotes
SET sAA=%~3
SET sA=%~4
SET sG=%~5
SET sT=%~6

REM Get output filename
SET sOutPath=%~dp2
SET sOutFile=%~n1
SET sOutFile=%sOutPath%%sOutFile%.%sEncoderFileExtension%

REM Create Encoder Options String
SET sEncoderOptions=-o "%sOutFile%"
SET sEncoderOptions=%sEncoderOptions% --delete-input-file
SET sEncoderOptions=%sEncoderOptions% -V
SET sEncoderOptions=%sEncoderOptions% --replay-gain
SET sEncoderOptions=%sEncoderOptions% -T "Album=%sA%"
SET sEncoderOptions=%sEncoderOptions% -T "AlbumArtist=%sAA%"
SET sEncoderOptions=%sEncoderOptions% -T "AlbumDate=%9"
rem SET sEncoderOptions=%sEncoderOptions% -T "Albums=1"
rem SET sEncoderOptions=%sEncoderOptions% -T "Disc=1"
rem SET sEncoderOptions=%sEncoderOptions% -T "Discs=1"
rem SET sEncoderOptions=%sEncoderOptions% -T "ReleaseStatus=Official"
SET sEncoderOptions=%sEncoderOptions% -T "Tracks=%8"
SET sEncoderOptions=%sEncoderOptions% -T "TrackNumber=%7"
SET sEncoderOptions=%sEncoderOptions% -T "Dancable=Yes"
SET sEncoderOptions=%sEncoderOptions% -T "Genre=%sG%"
SET sEncoderOptions=%sEncoderOptions% -T "Keyword=!"
SET sEncoderOptions=%sEncoderOptions% -T "Mood=!"
SET sEncoderOptions=%sEncoderOptions% -T "Tempo=!"
SET sEncoderOptions=%sEncoderOptions% -T "Composer=!"
SET sEncoderOptions=%sEncoderOptions% -T "TrackDate=%9"
SET sEncoderOptions=%sEncoderOptions% -T "Language=English"
SET sEncoderOptions=%sEncoderOptions% -T "Location=!"
SET sEncoderOptions=%sEncoderOptions% -T "Performer=%sAA%"
rem SET sEncoderOptions=%sEncoderOptions% -T "Studio/Live=Studio"
SET sEncoderOptions=%sEncoderOptions% -T "Title=%sT%"
rem SET sEncoderOptions=%sEncoderOptions% -T "Version=Original"
SET sEncoderOptions=%sEncoderOptions% -8
SET sEncoderOptions=%sEncoderOptions% %1

REM Start a new Command Processor so that this one can exit and
REM   CDex can continue ripping the next track
REM   while the encoder is doing its thing.
START /MIN "%7-%sT%" "%sEncoderFile%" %sEncoderOptions%

REM Need to wait for START to start !?
PING -n 2 127.0.0.1 >NUL

GOTO FLAC_Exit

:FLAC_Err_NotWinNTx
ECHO You need to be running WinNT, Win2000, or WinXP.
PAUSE

:FLAC_Exit